# docker image, we need a image with chrome installed so we can run unit tests in a virtualized environment such as docker containers
image: "registry.gitlab.com/gitlab-org/gitlab-build-images:ruby-2.6.5-golang-1.12-git-2.24-lfs-2.9-chrome-73.0-node-12.x-yarn-1.21-postgresql-9.6-graphicsmagick-1.3.34"

variables:
  USER_GITLAB: blub007
  APP_NAME: zkpfr-frontend-ci
  REPO_NAME: zkpfr-frontend
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CLI_VERSION: 9.1.0

#the majority of our builds require npm dependencies
before_script:
  - npm install


# thre stages, build -> unit tests and compilation, release -> docker image creation, deploy-> start created image on a remote server
stages:
  - tests-build
  - release
  - deploy

test:karma:
  stage: tests-build
  image: trion/ng-cli-karma:${CLI_VERSION}
  allow_failure: false
  script:
    - ng test --progress false --watch false

build:
  stage: tests-build
  script:
    - npm run-script build
  artifacts: #take the output of the compilation and transfer it to gain speed and create a docker image out of it
    paths:
      - dist/

image-creation:
  image: docker:git
  stage: release
  services:
    - docker:dind #used to be able to execute docker commands inside of a docker container
  before_script:
    - docker ps #overrides previous docker script
  script:
    # Non interactive ssh gracefully reloads server
    - docker login -u $CI_REGISTRY_USER -p $DOCKER_CI_TOKEN registry.gitlab.com #logs into gitlab docker registery, make sure to have this variables defined
    - docker build -t $CONTAINER_TEST_IMAGE .
    - docker push $CONTAINER_TEST_IMAGE
  only:
    # Trigger deployments only from master branch
    - master
  dependencies:
    - build #dependent on build to get the dist directory
    - test:karma


deploy:
  image: ubuntu
  before_script: #checks if ssh installed and if not, attempts to install it
    - "which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )"
    - eval $(ssh-agent -s)
    # Inject the remote's private key ssh-add <(echo "$STAGING_PRIVATE_KEY")
    # - echo "$PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - ssh-add <(echo "$PRIVATE_KEY" | base64 -d)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    # Append keyscan output into known hosts
    - ssh-keyscan $SERVER_IP_ADDRESS >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  stage: deploy #new stage after release
  script:
    # Non interactive ssh gracefully reloads server
    - ssh $SERVER_USER@$SERVER_IP_ADDRESS  ls
    - ssh $SERVER_USER@$SERVER_IP_ADDRESS "docker login -u ${CI_REGISTRY_USER} -p ${DOCKER_CI_TOKEN} registry.gitlab.com;
     docker stop angular-ci;
     docker rm angular-ci;
     docker rmi "$(docker images -aq)";
     docker pull ${CONTAINER_TEST_IMAGE};
     docker run --name angular-ci -d -p 80:80 ${CONTAINER_TEST_IMAGE}"

  only:
    # Trigger deployments only from master branch
    - master
  dependencies:
   - image-creation #dependency on creating a docker image with latest changes
